%define subrel 1

Summary:   A fast, lightweight distributed source control management system
Name:      mercurial
Version:   3.1.1
Release:   %mkrel 5
License:   GPLv2+
Group:     Development/Other
URL:       http://www.selenic.com/mercurial/
Source0:   http://www.selenic.com/mercurial/release/%{name}-%{version}.tar.gz
# PATCH-FIX-UPSTREAM mercurial-CVE-2014-9462.patch tiwai@suse.de - CVE-2014-9462, bnc#923070
Patch0:    mercurial-CVE-2014-9462.patch
# PATCH-FIX-UPSTREAM CVE-2016-3630, mga#18124
Patch101:       hg-CVE-2016-3630-parsers_detect_short_records.patch
Patch102:       hg-CVE-2016-3630-parsers_fix_list_sizing_rounding_error.patch
# PATCH-FIX-UPSTREAM CVE-2016-3068, mga#18124
Patch103:       hg-CVE-2016-3068-subrepo_set_GIT_ALLOW_PROTOCOL.patch
# PATCH-FIX-UPSTREAM Preliminary change for CVE-2016-3069, mga#18124
Patch104:       hg-convert_allow_customizing_git_remote_prefix.patch
Patch105:       hg-convert_fix_git_convert_using_servers_branches.name 
# PATCH-FIX-UPSTREAM CVE-2016-3069, mga#18124
Patch106:       hg-CVE-2016-3069-01-convert_add_new_non_clowny_interface.patch
Patch107:       hg-CVE-2016-3069-02-convert_rewrite_calls_to_Git.patch
Patch108:       hg-CVE-2016-3069-03-convert_dead_code_removal.patch
Patch109:       hg-CVE-2016-3069-04-convert_rewrite_gitpipe.patch
Patch110:       hg-CVE-2016-3069-05-convert_test_for_shell_injection.patch

BuildRequires: pkgconfig(python)
BuildRequires: xmlto
BuildRequires: asciidoc
BuildRequires: python-docutils
Provides: hg = %{version}-%{release}

%description
Mercurial is a fast, lightweight source control management system
designed for efficient handling of very large distributed
projects. 


%prep
%setup -q
%patch0 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1

%build
%make all

%install
%{__python} setup.py install -O1 --root $RPM_BUILD_ROOT --prefix %{_prefix} 
make install-doc DESTDIR=$RPM_BUILD_ROOT MANDIR=%{_mandir}

install contrib/hgk          $RPM_BUILD_ROOT%{_bindir}
install contrib/convert-repo $RPM_BUILD_ROOT%{_bindir}/mercurial-convert-repo
install contrib/hg-ssh       $RPM_BUILD_ROOT%{_bindir}

bash_completion_dir=$RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d
mkdir -p $bash_completion_dir
install -m 644 contrib/bash_completion $bash_completion_dir/mercurial.sh

zsh_completion_dir=$RPM_BUILD_ROOT%{_datadir}/zsh/site-functions
mkdir -p $zsh_completion_dir
install -m 644 contrib/zsh_completion $zsh_completion_dir/_mercurial

lisp_dir=$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
mkdir -p $lisp_dir
install -m 644 contrib/mercurial.el $lisp_dir
install -m 644 contrib/mq.el $lisp_dir

xlisp_dir=$RPM_BUILD_ROOT%{_datadir}/xemacs/site-packages/lisp
mkdir -p $xlisp_dir
install -m 644 contrib/mercurial.el $xlisp_dir
install -m 644 contrib/mq.el $xlisp_dir

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/mercurial/hgrc.d
install -m 644 contrib/mergetools.hgrc $RPM_BUILD_ROOT/%{_sysconfdir}/mercurial/hgrc.d/mergetools.rc

%files
%doc CONTRIBUTORS COPYING doc/README doc/hg*.txt doc/hg*.html *.cgi contrib/*.fcgi
%doc %attr(644,root,root) contrib/*.svg contrib/sample.hgrc
%dir %{_sysconfdir}/mercurial
%dir %{_sysconfdir}/mercurial/hgrc.d
%config(noreplace) %{_sysconfdir}/mercurial/hgrc.d/mergetools.rc
%{_mandir}/man*/*
%{_sysconfdir}/bash_completion.d/mercurial.sh
%{_datadir}/zsh/site-functions/_mercurial
%{_datadir}/emacs/site-lisp/*.el
%{_datadir}/xemacs/site-packages/lisp/*.el
%{_bindir}/hg
%{_bindir}/hgk
%{_bindir}/hg-ssh
%{_bindir}/mercurial-convert-repo
%{python_sitearch}/mercurial
%{python_sitearch}/mercurial*.egg-info
%{python_sitearch}/hgext



%changelog
* Wed Apr 06 2016 philippem <philippem> 3.1.1-5.1.mga5
+ Revision: 998978
- fix CVE-2016-3630, CVE-2016-3069, CVE-2016-3068 mga#18124

* Tue Mar 31 2015 philippem <philippem> 3.1.1-5.mga5
+ Revision: 819483
- fix CVE-2014-9462 mga#15590

* Wed Oct 15 2014 umeabot <umeabot> 3.1.1-4.mga5
+ Revision: 741948
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 3.1.1-3.mga5
+ Revision: 727232
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 3.1.1-2.mga5
+ Revision: 682360
- Mageia 5 Mass Rebuild

* Sat Sep 06 2014 philippem <philippem> 3.1.1-1.mga5
+ Revision: 672526
- update to 3.1.1

* Tue Aug 05 2014 philippem <philippem> 3.1-1.mga5
+ Revision: 659967
- update to 3.1

* Mon Jul 14 2014 philippem <philippem> 3.0.2-1.mga5
+ Revision: 651885
- update to 3.0.2

* Wed Jun 11 2014 philippem <philippem> 3.0.1-1.mga5
+ Revision: 635688
- update to 3.0.1

* Sat May 31 2014 pterjan <pterjan> 3.0-2.mga5
+ Revision: 628329
- Rebuild for new Python

* Sat May 10 2014 philippem <philippem> 3.0-1.mga5
+ Revision: 621841
- update to 3.0

* Fri Apr 25 2014 philippem <philippem> 2.9.2-1.mga5
+ Revision: 618094
- update to 2.9.2

* Sun Mar 02 2014 philippem <philippem> 2.9.1-1.mga5
+ Revision: 598610
- Update to 2.9.1

* Tue Oct 22 2013 umeabot <umeabot> 2.7.2-3.mga4
+ Revision: 542715
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 2.7.2-2.mga4
+ Revision: 497876
- Rebuild to add different pythonegg provides for python 2 and 3

* Fri Oct 04 2013 philippem <philippem> 2.7.2-1.mga4
+ Revision: 491476
- update to 2.7.2

* Fri Sep 13 2013 philippem <philippem> 2.7.1-1.mga4
+ Revision: 478650
- update to 2.7.1

* Sun Aug 25 2013 philippem <philippem> 2.7-1.mga4
+ Revision: 471721
- update to 2.7

* Tue Jul 02 2013 philippem <philippem> 2.6.3-1.mga4
+ Revision: 449781
- new version 2.6.3

* Sun Apr 21 2013 kamil <kamil> 2.5.4-1.mga4
+ Revision: 410693
- new version 2.5.4

* Sat Mar 02 2013 kamil <kamil> 2.5.2-1.mga3
+ Revision: 400977
- new version 2.5.2

* Sat Feb 16 2013 philippem <philippem> 2.5.1-1.mga3
+ Revision: 398745
- Update to new upstream

* Sun Feb 03 2013 kamil <kamil> 2.5-1.mga3
+ Revision: 394250
- new version 2.5

* Sat Jan 12 2013 umeabot <umeabot> 2.4.2-2.mga3
+ Revision: 359970
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 philippem <philippem> 2.4.2-1.mga3
+ Revision: 339054
- Update to new upstream 2.4.2

* Sat Dec 22 2012 kamil <kamil> 2.4.1-2.mga3
+ Revision: 333829
- clean .spec a bit

* Fri Dec 14 2012 philippem <philippem> 2.4.1-1.mga3
+ Revision: 331008
- update to 2.4.1

* Thu Nov 15 2012 philippem <philippem> 2.4-1.mga3
+ Revision: 318300
- Update to 2.4

* Sat Sep 22 2012 philippem <philippem> 2.3.1-1.mga3
+ Revision: 296762
- Update to 2.3.1.

* Sun Sep 02 2012 philippem <philippem> 2.3-1.mga3
+ Revision: 287225
- New upstream release 2.3

* Tue Mar 06 2012 philippem <philippem> 2.1.1-1.mga2
+ Revision: 220065
- Update to 2.1.1.

* Sat Feb 11 2012 philippem <philippem> 2.1-1.mga2
+ Revision: 207304
- Update to 2.1.

* Sun Jan 08 2012 philippem <philippem> 2.0.2-1.mga2
+ Revision: 193242
- Update to 2.0.2.

* Fri Dec 02 2011 lebedov <lebedov> 2.0.1-2.mga2
+ Revision: 175144
- Shorten description.

* Fri Dec 02 2011 lebedov <lebedov> 2.0.1-1.mga2
+ Revision: 175139
- Update to 2.0.1.

* Thu Nov 03 2011 philippem <philippem> 2.0-1.mga2
+ Revision: 162046
- Update to 2.0.

* Mon Oct 03 2011 lebedov <lebedov> 1.9.3-1.mga2
+ Revision: 151409
- Update to 1.9.3.

* Wed Sep 21 2011 philippem <philippem> 1.9.2-1.mga2
+ Revision: 146436
- Update to 1.9.2

* Mon Jul 04 2011 philippem <philippem> 1.9-1.mga2
+ Revision: 118071
- Update to 1.9

* Mon May 02 2011 philippem <philippem> 1.8.3-2.mga1
+ Revision: 94204
- Update to 1.8.3

* Sat Apr 30 2011 misc <misc> 1.8.2-1.mga1
+ Revision: 93867
- update to 1.8.2 ( ease upgrade from mandriva, and bugfixes only release )

* Sat Apr 16 2011 misc <misc> 1.8.1-1.mga1
+ Revision: 86180
- update to 1.8.1

* Fri Feb 04 2011 philippem <philippem> 1.7.5-1.mga1
+ Revision: 46853
- imported package mercurial
- build with new upstream 1.7.5


* Sun Jan 02 2011 Lev Givon <lev@mandriva.org> 1.7.3-1mdv2011.0
+ Revision: 627547
- Update to 1.7.3.

* Thu Dec 02 2010 Lev Givon <lev@mandriva.org> 1.7.2-1mdv2011.0
+ Revision: 604819
- Update to 1.7.2.

* Wed Nov 17 2010 Lev Givon <lev@mandriva.org> 1.7.1-1mdv2011.0
+ Revision: 598134
- Update to 1.7.1.

* Sat Oct 30 2010 Michael Scherer <misc@mandriva.org> 1.6.4-3mdv2011.0
+ Revision: 590353
- rebuild for python 2.7

* Fri Oct 08 2010 Lev Givon <lev@mandriva.org> 1.6.4-1mdv2011.0
+ Revision: 584245
- Update to 1.6.4.

* Fri Aug 27 2010 Lev Givon <lev@mandriva.org> 1.6.3-1mdv2011.0
+ Revision: 573469
- Update to 1.6.3.

* Tue Aug 03 2010 Lev Givon <lev@mandriva.org> 1.6.2-1mdv2011.0
+ Revision: 565216
- Update to 1.6.2.

* Mon Jul 19 2010 Lev Givon <lev@mandriva.org> 1.6-1mdv2011.0
+ Revision: 554965
- Update to 1.6.

* Tue Jun 01 2010 Lev Givon <lev@mandriva.org> 1.5.4-1mdv2010.1
+ Revision: 546850
- Update to 1.5.4.
- Update to 1.5.3.

* Fri Apr 02 2010 Lev Givon <lev@mandriva.org> 1.5.1-1mdv2010.1
+ Revision: 530772
- Update to 1.5.1.

* Sun Mar 07 2010 Lev Givon <lev@mandriva.org> 1.5-1mdv2010.1
+ Revision: 515466
- Update to 1.5.

* Mon Feb 01 2010 Lev Givon <lev@mandriva.org> 1.4.3-1mdv2010.1
+ Revision: 499245
- Update to 1.4.3.

* Sat Jan 02 2010 Frederik Himpe <fhimpe@mandriva.org> 1.4.2-1mdv2010.1
+ Revision: 484958
- update to new version 1.4.2

* Wed Dec 02 2009 Lev Givon <lev@mandriva.org> 1.4.1-1mdv2010.1
+ Revision: 472619
- Update to 1.4.1.

* Tue Nov 17 2009 Frederik Himpe <fhimpe@mandriva.org> 1.4-1mdv2010.1
+ Revision: 467008
- update to new version 1.4

* Thu Jul 23 2009 Frederik Himpe <fhimpe@mandriva.org> 1.3.1-1mdv2010.0
+ Revision: 399117
- update to new version 1.3.1

* Fri Jul 03 2009 Lev Givon <lev@mandriva.org> 1.3-1mdv2010.0
+ Revision: 391921
- Update to 1.3.

* Sat Mar 21 2009 Frederik Himpe <fhimpe@mandriva.org> 1.2.1-1mdv2009.1
+ Revision: 359983
- update to new version 1.2.1

* Sun Mar 08 2009 Frederik Himpe <fhimpe@mandriva.org> 1.2-1mdv2009.1
+ Revision: 352891
- update to new version 1.2

* Sat Jan 03 2009 Jérôme Soyer <saispo@mandriva.org> 1.1.2-1mdv2009.1
+ Revision: 323882
- New upstream release

* Thu Dec 25 2008 Michael Scherer <misc@mandriva.org> 1.1-2mdv2009.1
+ Revision: 318497
- rebuild for new python

* Sat Dec 20 2008 Olivier Thauvin <nanardon@mandriva.org> 1.1-1mdv2009.1
+ Revision: 316544
- 1.1

* Fri Aug 15 2008 Lev Givon <lev@mandriva.org> 1.0.2-1mdv2009.0
+ Revision: 272385
- Update to 1.0.2.

* Fri Aug 08 2008 Thierry Vignaud <tv@mandriva.org> 1.0.1-2mdv2009.0
+ Revision: 268141
- rebuild early 2009.0 package (before pixel changes)

* Sun Jun 01 2008 Lev Givon <lev@mandriva.org> 1.0.1-1mdv2009.0
+ Revision: 214142
- Update to 1.0.1.

* Sun Apr 13 2008 Lev Givon <lev@mandriva.org> 1.0-1mdv2009.0
+ Revision: 192649
- Update to 1.0.

* Sat Mar 01 2008 Nicolas Lécureuil <nlecureuil@mandriva.com> 0.9.5-2mdv2008.1
+ Revision: 177399
- Fix group
- Sync spec file with fedora
  Add cgi files (Bug #36194)

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Nov 09 2007 Jérôme Soyer <saispo@mandriva.org> 0.9.5-1mdv2008.1
+ Revision: 107084
- New release

* Tue Jul 17 2007 Jérôme Soyer <saispo@mandriva.org> 0.9.4-1mdv2008.0
+ Revision: 53115
- New release


* Tue Dec 19 2006 Gaëtan Lehmann <glehmann@mandriva.org> 0.9.3-1mdv2007.0
+ Revision: 100353
- 0.9.3

* Mon Dec 18 2006 Gaëtan Lehmann <glehmann@mandriva.org> 0.9.2-2mdv2007.1
+ Revision: 98735
- bump release
- 0.9.2

* Wed Dec 06 2006 Thierry Vignaud <tvignaud@mandriva.com> 0.9-2mdv2007.1
+ Revision: 91457
- rebuild with new python

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - import mercurial-0.9-1mdk

* Sat May 13 2006 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 0.9-1mdk
- New release 0.9

* Wed Feb 01 2006 Gaetan Lehmann <glehmann@deborah.mandriva.com> 0.8-2mdk
- fix build on x86_64 (drop patch0)

* Tue Jan 31 2006 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 0.8-1mdk
- New release 0.8

* Fri Oct 21 2005 Nicolas Lcureuil <neoclust@mandriva.org> 0.7-2mdk
- Fix BuildRequires

* Wed Oct 05 2005 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 0.7-1mdk
- New release 0.7

* Fri Sep 09 2005 Gaetan Lehmann <glehmann@mandrakesoft.com> 0.6c-1mdk
- New release 0.6c
- generate doc with asciidoc
- make tests
- patch0: better detection of lib name to allow tests to run on 32 bits
  system with a /usr/lib64 directory (like n4 on mandriva cluster)

* Fri Jun 03 2005 Frederic Lepied <flepied@mandriva.com> 0.5b-1mdk
- initial package

